xine-lib: xine-lib-1.2.13/src/post/audio/filter.h File Reference

xine-lib 1.2.13-20230125hg15249

Macros | Functions
filter.h File Reference

Go to the source code of this file.

## Macros
#define | LP 0x00010000 /* Low pass */
#define | HP 0x00020000 /* High pass */
#define | BP 0x00040000 /* Band pass */
#define | BS 0x00080000 /* Band stop */
#define | TYPE_MASK 0x000F0000
#define | BOXCAR 0x00000001
#define | TRIANG 0x00000002
#define | HAMMING 0x00000004
#define | HANNING 0x00000008
#define | BLACKMAN 0x00000010
#define | FLATTOP 0x00000011
#define | KAISER 0x00000012
#define | WINDOW_MASK 0x0000001F
#define | FWD 0x00000001 /* Forward indexing of polyphase filter */
#define | REW 0x00000002 /* Reverse indexing of polyphase filter */
#define | ODD 0x00000010 /* Make filter HP */
#define | updateq(n, xi, xq, in)

## Functions
_ftype_t | fir (unsigned int n, _ftype_t *w, _ftype_t *x)
_ftype_t * | pfir (unsigned int n, unsigned int k, unsigned int xi, _ftype_t **w, _ftype_t **x, _ftype_t *y, unsigned int s)
int | updateq (unsigned int n, unsigned int xi, _ftype_t *xq, _ftype_t *in)
int | updatepq (unsigned int n, unsigned int k, unsigned int xi, _ftype_t **xq, _ftype_t *in, unsigned int s)
int | design_fir (unsigned int n, _ftype_t *w, _ftype_t *fc, unsigned int flags, _ftype_t opt)
int | design_pfir (unsigned int n, unsigned int k, _ftype_t *w, _ftype_t **pw, _ftype_t g, unsigned int flags)
void | prewarp (_ftype_t *a, _ftype_t fc, _ftype_t fs)
void | bilinear (_ftype_t *a, _ftype_t *b, _ftype_t *k, _ftype_t fs, _ftype_t *coef)
int | szxform (const _ftype_t *a, const _ftype_t *b, _ftype_t Q, _ftype_t fc, _ftype_t fs, _ftype_t *k, _ftype_t *coef)

## Macro Definition Documentation

## ◆ BLACKMAN

#define BLACKMAN 0x00000010

Referenced by design_fir().

## ◆ BOXCAR

#define BOXCAR 0x00000001

Referenced by design_fir().

## ◆ BP

#define BP 0x00040000 /* Band pass */

Referenced by design_fir().

## ◆ BS

#define BS 0x00080000 /* Band stop */

Referenced by design_fir().

## ◆ FLATTOP

#define FLATTOP 0x00000011

Referenced by design_fir().

## ◆ FWD

#define FWD 0x00000001 /* Forward indexing of polyphase filter */

## ◆ HAMMING

#define HAMMING 0x00000004

Referenced by design_fir().

## ◆ HANNING

#define HANNING 0x00000008

Referenced by design_fir().

## ◆ HP

#define HP 0x00020000 /* High pass */

Referenced by design_fir().

## ◆ KAISER

#define KAISER 0x00000012

Referenced by design_fir().

## ◆ LP

#define LP 0x00010000 /* Low pass */

Referenced by design_fir().

## ◆ ODD

#define ODD 0x00000010 /* Make filter HP */

Referenced by design_pfir().

## ◆ REW

#define REW 0x00000002 /* Reverse indexing of polyphase filter */

Referenced by design_pfir().

## ◆ TRIANG

#define TRIANG 0x00000002

Referenced by design_fir().

## ◆ TYPE_MASK

#define TYPE_MASK 0x000F0000

## ◆ updateq

#define updateq | ( |  | n,
|  |  | xi,
|  |  | xq,
|  |  | in )

Value:
xq[xi]=(xq)[(xi)+(n)]=*(in);\
xi=(++(xi))&((n)-1);

## ◆ WINDOW_MASK

#define WINDOW_MASK 0x0000001F

Referenced by design_fir().

## Function Documentation

## ◆ bilinear()

void bilinear | ( | _ftype_t * | a,
|  | _ftype_t * | b,
|  | _ftype_t * | k,
|  | _ftype_t | fs,
|  | _ftype_t * | coef )

## ◆ design_fir()

int design_fir | ( | unsigned int | n,
|  | _ftype_t * | w,
|  | _ftype_t * | fc,
|  | unsigned int | flags,
|  | _ftype_t | opt )
| extern

## ◆ design_pfir()

int design_pfir | ( | unsigned int | n,
|  | unsigned int | k,
|  | _ftype_t * | w,
|  | _ftype_t ** | pw,
|  | _ftype_t | g,
|  | unsigned int | flags )
| extern

## ◆ fir()

_ftype_t fir | ( | unsigned int | n,
|  | _ftype_t * | w,
|  | _ftype_t * | x )
| extern

## ◆ pfir()

_ftype_t * pfir | ( | unsigned int | n,
|  | unsigned int | k,
|  | unsigned int | xi,
|  | _ftype_t ** | w,
|  | _ftype_t ** | x,
|  | _ftype_t * | y,
|  | unsigned int | s )
| extern

## ◆ prewarp()

void prewarp | ( | _ftype_t * | a,
|  | _ftype_t | fc,
|  | _ftype_t | fs )
| extern

## ◆ szxform()

int szxform | ( | const _ftype_t * | a,
|  | const _ftype_t * | b,
|  | _ftype_t | Q,
|  | _ftype_t | fc,
|  | _ftype_t | fs,
|  | _ftype_t * | k,
|  | _ftype_t * | coef )
| extern

## ◆ updatepq()

int updatepq | ( | unsigned int | n,
|  | unsigned int | k,
|  | unsigned int | xi,
|  | _ftype_t ** | xq,
|  | _ftype_t * | in,
|  | unsigned int | s )
| extern

## ◆ updateq()

int updateq | ( | unsigned int | n,
|  | unsigned int | xi,
|  | _ftype_t * | xq,
|  | _ftype_t * | in )
| extern